package com.sd.business.controller.excel;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.BaseSelectDto;
import com.sd.business.entity.excel.dto.ExcelGenerateLogDto;
import com.sd.business.entity.excel.dto.ExcelGenerateLogSelectDto;
import com.sd.business.entity.excel.vo.ExcelGenerateLogVo;
import com.sd.business.service.excel.ExcelGenerateLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * <p>
 * excel生成记录 前端控制器
 * </p>
 *
 * @author
 * @since 2024-01-17
 */
@RestController
@RequestMapping("/excelGenerateLog")
public class ExcelGenerateLogController {

    @Autowired
    private ExcelGenerateLogService excelGenerateLogService;

    /**
     * excel生成记录分页
     */
    @PostMapping("/page")
    public Page<ExcelGenerateLogVo> page(@RequestBody ExcelGenerateLogSelectDto dto) {
        return excelGenerateLogService.getPage(dto);
    }

    /**
     * excel生成记录明细
     */
    @PostMapping("/detail")
    public ExcelGenerateLogVo detail(@RequestBody BaseSelectDto dto) {
        return excelGenerateLogService.detail(dto.getId());
    }

    /**
     * excel生成记录新增
     */
    @PostMapping("/add")
    public void add(@RequestBody ExcelGenerateLogDto dto) {
        excelGenerateLogService.add(dto);
    }

    /**
     * excel生成记录编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody ExcelGenerateLogDto dto) {
        excelGenerateLogService.edit(dto);
    }

    /**
     * excel生成记录删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        excelGenerateLogService.delete(dto.getId());
    }

}
