package com.sd.business.service.contract.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sd.business.entity.contract.dto.ContractTemplateDto;
import com.sd.business.entity.contract.dto.ContractTemplateSelectDto;
import com.sd.business.entity.contract.po.ContractTemplate;
import com.sd.business.entity.contract.vo.ContractTemplateVo;
import com.sd.business.mapper.contract.ContractTemplateMapper;
import com.sd.business.service.contract.ContractTemplateService;
import com.sd.framework.util.Assert;
import com.sd.framework.util.sql.Sql;
import org.springframework.stereotype.Service;


/**
 * <p>
 * 合同模板 服务实现类
 * </p>
 *
 * @author
 * @since 2024-01-15
 */
@Service
public class ContractTemplateServiceImpl extends ServiceImpl<ContractTemplateMapper, ContractTemplate> implements ContractTemplateService {

    @Override
    public Page<ContractTemplateVo> getPage(ContractTemplateSelectDto dto) {

        Page<ContractTemplateVo> page = Sql.create(ContractTemplateVo.class)
                .selectAll(ContractTemplate.class)
                .from(ContractTemplate.class)
                .orderByDesc(ContractTemplate::getId)
                .page(dto);

        return page;
    }

    @Override
    public ContractTemplateVo detail(Long id) {

        ContractTemplateVo vo = Sql.create(ContractTemplateVo.class)
                .selectAll(ContractTemplate.class)
                .from(ContractTemplate.class)
                .eq(ContractTemplate::getId, id)
                .one();

        Assert.notNull(vo, "未知数据");

        return vo;
    }

    @Override
    public void add(ContractTemplateDto dto) {
        save(dto);
    }

    @Override
    public void edit(ContractTemplateDto dto) {
        updateById(dto);
    }

    @Override
    public void delete(Long id) {
        removeById(id);
    }

}
