import cn.hutool.core.thread.ThreadUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.db.Entity;
import cn.hutool.db.Session;
import cn.hutool.db.ds.simple.SimpleDataSource;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.StringPool;
import lombok.extern.slf4j.Slf4j;

import javax.sql.DataSource;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Slf4j
public class Test {

    private static final String cookie = "_ati=5871260192792; priceDecimal=4; user-key=558593628374497833; UM_distinctid=18d0bb4e1c12246-0c0e60421d504c-26001951-1bcab9-18d0bb4e1c229d6; domesticSymbol=%uFFE5; sale.query=200; x-device-fingerprints=693553932ed740734732bfcc85733634; ERPSESSIONID=c5203737d4983767fb197038a17233d3; CALFSESSIONID=c5203737d4983767fb197038a17233d3; SESSION=93803a2b-ea0e-49d1-9de4-708965df5c69; CNZZDATA1259815538=758486602-1705298422-https%253A%252F%252Ferp.hupun.com%252F%7C1705364889";


    public static void main(String[] args) throws SQLException {

        DataSource ds = new SimpleDataSource("jdbc:mysql://localhost:3306/fly_back", "root", "root");
        Session session = Session.create(ds);

        int pageNo = 60;
        List<JSONObject> list;
        do {

            System.out.println(pageNo);
            list = getList(pageNo, "2023-04-16T00:00:00Z", "2024-07-15T23:59:59Z");
            pageNo++;

            List<Entity> entityList = new ArrayList<>();

            for (JSONObject object : list) {
                JSONObject jsonObject;
                do {
                    jsonObject = getJsonObject(object);
                    ThreadUtil.sleep(100);
                    if (jsonObject == null) {
                        ThreadUtil.sleep(2 * 60 * 1000);
                    }
                } while (jsonObject == null);

                if (Objects.equals(jsonObject.getBoolean("return"), true)) {
                    continue;
                }

                // 购买人
                String name = unicodeDecode(jsonObject.getString("tp_receiver_name"));
                // 电话号码
                String mobile = jsonObject.getString("tp_receiver_mobile");
                // 省
                String state = object.getString("tp_receiver_state");
                // 市
                String city = object.getString("tp_receiver_city");
                // 县
                String district = object.getString("tp_receiver_district");
                // 区
                String town = object.getString("tp_receiver_town");
                // 详细地址
                String address = unicodeDecode(jsonObject.getString("tp_receiver_address"));

                Entity entity = Entity.create("area")
                        .set("name", name)
                        .set("mobile", mobile)
                        .set("state", state)
                        .set("city", city)
                        .set("district", district)
                        .set("town", town)
                        .set("address", address);
                entityList.add(entity);
            }

            for (Entity entity : entityList) {
                session.insert(entity);
            }

            ThreadUtil.sleep(1000 * 60 * 2);

        } while (list.size() == 100);


        System.out.println();
    }

    private static JSONObject getJsonObject(JSONObject object) {
        String salercptUid = object.getString("salercpt_uid");
        String salercptNo = object.getString("salercpt_no");

        HttpResponse result = HttpUtil.createPost("https://erp-e.hupun.com/dorado/view-service")
                .header("authority", "erp-e.hupun.com")
                .header("method", "POST")
                .header("path", "/dorado/view-service")
                .header("scheme", "https")
                .header("Accept", "*/*")
                .header("Accept-Encoding", "gzip, deflate, br")
                .header("Accept-Language", "zh-CN,zh;q=0.9")
                .header("Content-Length", "3807")
                .header("Content-Type", "text/javascript")
                .header("Origin", "https://erp-e.hupun.com")
                .header("Referer", "https://erp-e.hupun.com/sale.query.d?_calf=erp-web")
                .header("Sec-Ch-Ua", "\"Not_A Brand\";v=\"8\", \"Chromium\";v=\"120\", \"GoogleChrome\"v=\"120\"")
                .header("Sec-Ch-Ua-Mobile", "?0")
                .cookie(cookie)
                .body(getMap(salercptUid, salercptNo))
                .execute();

        String body = result.body();

        if (body.contains("当前操作失败,原因：您好，订单解密失败，失败原因：业务处理失败:解密错误: 批量解密存在部分失败:基于消费者隐私保护，该订单状态禁止查看")
                || body.contains("当前操作失败,原因：您好，订单解密失败，失败原因：caid解析错误，请检查订单号、caid、调用者是否匹配")) {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("return", true);
            return jsonObject;
        }

        try {
            return JSONObject.parseObject(body).getJSONArray("data").toJavaList(JSONObject.class).get(0);
        } catch (Exception e) {
            System.out.println(body);
        }

        return null;
    }

    private static List<JSONObject> getList(int pageNo, String startDate, String endDate) {
        HttpResponse execute = HttpUtil.createPost("https://erp-e.hupun.com/dorado/view-service")
                .header("authority", "erp-e.hupun.com")
                .header("method", "POST")
                .header("path", "/dorado/view-service")
                .header("scheme", "https")
                .header("Accept", "*/*")
                .header("Accept-Encoding", "gzip, deflate, br")
                .header("Accept-Language", "zh-CN,zh;q=0.9")
                .header("Content-Length", "4852")
                .header("Content-Type", "text/xml")
                .header("Origin", "https://erp-e.hupun.com")
                .header("Referer", "https://erp-e.hupun.com/sale.query.d?_calf=erp-web")
                .header("Sec-Ch-Ua", "\"Not_A Brand\";v=\"8\", \"Chromium\";v=\"120\", \"Google Chrome\";v=\"120\"")
                .header("Sec-Ch-Ua-Mobile", "?0")
                .cookie(cookie)
                .body(getBody(pageNo, startDate, endDate))
                .execute();

        String body = execute.body().replace("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" +
                        "<result>\n" +
                        "<request>\n" +
                        "<response type=\"json\"><![CDATA[", "")
                .replace("]]></response>\n" +
                        "</request>\n" +
                        "</result>", "");

        JSONObject jsonObject = JSONObject.parseObject(body);
        return jsonObject.getJSONObject("data").getJSONArray("data").toList(JSONObject.class);
    }


    private static String getBody(int pageNo, String startDate, String endDate) {
        return "<batch>\n" +
                "<request type=\"json\"><![CDATA[{\"action\":\"load-data\",\"dataProvider\":\"saleInterceptor#queryTrade\",\"supportsEntity\":true,\"parameter\":{\"view\":\"sale.query\",\"dateType\":1,\"buyerType\":\"1\",\"exactType\":1,\"goodsType\":1,\"endDate\":\"" + endDate + "\",\"startDate\":\"" + startDate + "\",\"endTime\":\"" + endDate + "\",\"history\":false,\"specType\":1,\"showModify\":false,\"refund\":false,\"detail\":0,\"containsPackage\":false,\"noSpecContainsPkg\":false,\"invKind\":1,\"unRelated\":false,\"canMerge\":false,\"sendTimeType\":0,\"isMatchLoc\":0,\"refundStage\":0,\"triggerType\":\"0\",\"sys_shop\":\"\",\"distrUid\":\"\",\"showName\":\"\",\"storage_uid\":\"2DEFE7D252013F06AF39E5DE7B6762E0,877A12C20FE133B4953230C917E361ED,EDECDC10BC623595B416A59988607F9A,FB20BC0E214B31B9A910423B30273910,D8B8FD17E6FF3817898024DFA9CCCDC1,D7BF4E738962379BA4B30B4B192F0546,42F8D61E3D553C75AB0B67605F44D8CC,2821BA9B48F23C90AB7F7A254360807B,A7D0BE43FE4738C4A4355E3370A9D235,\",\"storage_name\":\"胜德实业A9仓,胜德实业A仓,胜德实业A8仓,胜德实业A1次品仓,胜德实业A4仓,胜德实业A1定制仓,胜德体育仓-A9,胜德体育仓-A1,胜德体育仓-A8,\",\"salemanUid\":\"\",\"saleman\":\"\",\"NOSIZE\":\"true\",\"$dataType\":\"dtSearch\"},\"resultDataType\":\"v:sale.query$[Trade]\",\"pageSize\":100,\"pageNo\":" + pageNo + ",\"context\":{\"switchContext\":{\"HIDE_WLN\":{},\"AUTO_ADD_OUTGOODS\":{\"extend\":null,\"cofco\":false,\"comUid\":\"22768050183124\",\"switchId\":420,\"kohlerCustomize\":false,\"zhongTao\":false,\"type\":null,\"storageUid\":null,\"yingTeYiNian\":false,\"value\":0,\"xiaoLinZhiYao\":false,\"status\":0},\"SENSITIVE_DATA_NOT_NOTIFY\":{},\"MAX_CHECK_TP_PAYMENT\":{\"extend\":null,\"cofco\":false,\"comUid\":\"22768050183124\",\"switchId\":371,\"kohlerCustomize\":false,\"zhongTao\":false,\"type\":null,\"storageUid\":null,\"yingTeYiNian\":false,\"value\":0,\"xiaoLinZhiYao\":false,\"status\":1},\"AMOUNT_IDENTITY_CHECK\":{\"extend\":null,\"cofco\":false,\"comUid\":\"22768050183124\",\"switchId\":3040,\"kohlerCustomize\":false,\"zhongTao\":false,\"type\":null,\"storageUid\":null,\"yingTeYiNian\":false,\"value\":0,\"xiaoLinZhiYao\":false,\"status\":0},\"VIP_CUSTOMIZE\":{},\"FORBIDDEN_CUSTOM_MARK_REASON\":{\"extend\":null,\"cofco\":false,\"comUid\":\"22768050183124\",\"switchId\":3037,\"kohlerCustomize\":false,\"zhongTao\":false,\"type\":null,\"storageUid\":null,\"yingTeYiNian\":false,\"value\":0,\"xiaoLinZhiYao\":false,\"status\":0},\"SET_EXCHANGE_ORDER_ZEOR\":{\"extend\":null,\"cofco\":false,\"comUid\":\"22768050183124\",\"switchId\":425,\"kohlerCustomize\":false,\"zhongTao\":false,\"type\":null,\"storageUid\":null,\"yingTeYiNian\":false,\"value\":0,\"xiaoLinZhiYao\":false,\"status\":0},\"COURIER_MATCH\":{},\"SPECIAL_MARK\":{},\"APPROVE_NEW_BANNER\":{\"extend\":\"\",\"cofco\":false,\"comUid\":\"22768050183124\",\"switchId\":3043,\"kohlerCustomize\":false,\"zhongTao\":false,\"type\":null,\"storageUid\":null,\"yingTeYiNian\":false,\"value\":0,\"xiaoLinZhiYao\":false,\"status\":0},\"APPROVE_NEW_TIP\":{},\"OPEN_SPLIT_OCCUPIED_ITEM\":{\"extend\":null,\"cofco\":false,\"comUid\":\"22768050183124\",\"switchId\":310,\"kohlerCustomize\":false,\"zhongTao\":false,\"type\":null,\"storageUid\":null,\"yingTeYiNian\":false,\"value\":0,\"xiaoLinZhiYao\":false,\"status\":0},\"WMS_SEND_OUT_SEPARATE\":{},\"SPLIT_LIMITATION_ORDER\":{\"extend\":null,\"cofco\":false,\"comUid\":\"22768050183124\",\"switchId\":347,\"kohlerCustomize\":false,\"zhongTao\":false,\"type\":null,\"storageUid\":null,\"yingTeYiNian\":false,\"value\":0,\"xiaoLinZhiYao\":false,\"status\":0},\"DISTR_MARK_TYPE\":{},\"QUERY_GOODS_RIGHT_LIKE\":{},\"OPEN_OCCUPY_INVENTORY\":{\"extend\":null,\"cofco\":false,\"comUid\":\"22768050183124\",\"switchId\":1999,\"kohlerCustomize\":false,\"zhongTao\":false,\"type\":null,\"storageUid\":null,\"yingTeYiNian\":false,\"value\":0,\"xiaoLinZhiYao\":false,\"status\":1},\"REMARK_REPLACED_ORDER\":{\"extend\":null,\"cofco\":false,\"comUid\":\"22768050183124\",\"switchId\":1013,\"kohlerCustomize\":false,\"zhongTao\":false,\"type\":null,\"storageUid\":null,\"yingTeYiNian\":false,\"value\":0,\"xiaoLinZhiYao\":false,\"status\":0},\"LOT_WAREHOUSE\":{}}},\"loadedDataTypes\":[\"dtDeliveryRequirements\",\"dtSearchHistory\",\"PrintConfig\",\"Shop\",\"dtGroup\",\"Storage\",\"Region\",\"dtTradeStatementDetail\",\"batchInventory\",\"Trade\",\"dtException\",\"dtWriteOff\",\"CustomAddress\",\"dtMarkType\",\"dtSpecialMark\",\"Entity\",\"dtSide\",\"dtSearch\",\"dtInvoice\",\"Template\",\"dtBillRequirements\",\"MultiGroupShop\",\"dtOnwaySearch\",\"Country\",\"dtERPVideoStorageBean\",\"dtVidEquipmentDO\",\"Combination\",\"dtButtonDiy\",\"FinAccount\",\"dtDistributor\",\"dtQueryCondition\",\"CombinationGoods\",\"warehouse\",\"MultiStorage\",\"operBillType\",\"dtStorage\",\"Oper\",\"dtButton\",\"Order\",\"dtBackReason\",\"dtTradeStatus\",\"multiDistributor\",\"MultiShop\",\"dtSysShop\",\"GoodsSpec\",\"MultiOper\",\"dtOnway\",\"dtCombination\",\"DistrCompany\",\"CombinationDetail\",\"dtSearchGoods\",\"dtTradeAddition\",\"dtBatch\",\"dtGoodsUniqueCode\",\"dtMultiBarcode\",\"dtTradeTypeDTO\",\"dtSerialNumber\",\"TradeOccupyDetail\",\"TradeLog\",\"dtJzPartner\",\"dtTradeStatement\",\"GoodsPermissions\",\"dtSalePacking\",\"dtExchange\",\"dtMergeLog\",\"dtPackingDetail\",\"dtWorkOrder\",\"dtExchangeRecord\",\"dtJzPartnerNew\"]}]]></request>\n" +
                "</batch>";
    }


    private static String getMap(String ids, String salercptNo) {
        return "{\n" +
                "    \"action\": \"remote-service\",\n" +
                "    \"service\": \"saleInterceptor#getClearTradeMsg\",\n" +
                "    \"supportsEntity\": true,\n" +
                "    \"parameter\": {\n" +
                "        \"shopType\": 8,\n" +
                "        \"ids\": [\n" +
                "            \"" + ids + "\"\n" +
                "        ],\n" +
                "        \"sensitiveType\": [\n" +
                "            1,2,4\n" +
                "        ],\n" +
                "        \"salercptNo\": [\n" +
                "            \"" + salercptNo + "\"\n" +
                "        ]\n" +
                "    },\n" +
                "    \"context\": {\n" +
                "        \"switchContext\": {\n" +
                "            \"HIDE_WLN\": {},\n" +
                "            \"AUTO_ADD_OUTGOODS\": {\n" +
                "                \"extend\": null,\n" +
                "                \"cofco\": false,\n" +
                "                \"comUid\": \"22768050183124\",\n" +
                "                \"switchId\": 420,\n" +
                "                \"kohlerCustomize\": false,\n" +
                "                \"zhongTao\": false,\n" +
                "                \"type\": null,\n" +
                "                \"storageUid\": null,\n" +
                "                \"yingTeYiNian\": false,\n" +
                "                \"value\": 0,\n" +
                "                \"xiaoLinZhiYao\": false,\n" +
                "                \"status\": 0\n" +
                "            },\n" +
                "            \"SENSITIVE_DATA_NOT_NOTIFY\": {},\n" +
                "            \"MAX_CHECK_TP_PAYMENT\": {\n" +
                "                \"extend\": null,\n" +
                "                \"cofco\": false,\n" +
                "                \"comUid\": \"22768050183124\",\n" +
                "                \"switchId\": 371,\n" +
                "                \"kohlerCustomize\": false,\n" +
                "                \"zhongTao\": false,\n" +
                "                \"type\": null,\n" +
                "                \"storageUid\": null,\n" +
                "                \"yingTeYiNian\": false,\n" +
                "                \"value\": 0,\n" +
                "                \"xiaoLinZhiYao\": false,\n" +
                "                \"status\": 1\n" +
                "            },\n" +
                "            \"AMOUNT_IDENTITY_CHECK\": {\n" +
                "                \"extend\": null,\n" +
                "                \"cofco\": false,\n" +
                "                \"comUid\": \"22768050183124\",\n" +
                "                \"switchId\": 3040,\n" +
                "                \"kohlerCustomize\": false,\n" +
                "                \"zhongTao\": false,\n" +
                "                \"type\": null,\n" +
                "                \"storageUid\": null,\n" +
                "                \"yingTeYiNian\": false,\n" +
                "                \"value\": 0,\n" +
                "                \"xiaoLinZhiYao\": false,\n" +
                "                \"status\": 0\n" +
                "            },\n" +
                "            \"VIP_CUSTOMIZE\": {},\n" +
                "            \"FORBIDDEN_CUSTOM_MARK_REASON\": {\n" +
                "                \"extend\": null,\n" +
                "                \"cofco\": false,\n" +
                "                \"comUid\": \"22768050183124\",\n" +
                "                \"switchId\": 3037,\n" +
                "                \"kohlerCustomize\": false,\n" +
                "                \"zhongTao\": false,\n" +
                "                \"type\": null,\n" +
                "                \"storageUid\": null,\n" +
                "                \"yingTeYiNian\": false,\n" +
                "                \"value\": 0,\n" +
                "                \"xiaoLinZhiYao\": false,\n" +
                "                \"status\": 0\n" +
                "            },\n" +
                "            \"SET_EXCHANGE_ORDER_ZEOR\": {\n" +
                "                \"extend\": null,\n" +
                "                \"cofco\": false,\n" +
                "                \"comUid\": \"22768050183124\",\n" +
                "                \"switchId\": 425,\n" +
                "                \"kohlerCustomize\": false,\n" +
                "                \"zhongTao\": false,\n" +
                "                \"type\": null,\n" +
                "                \"storageUid\": null,\n" +
                "                \"yingTeYiNian\": false,\n" +
                "                \"value\": 0,\n" +
                "                \"xiaoLinZhiYao\": false,\n" +
                "                \"status\": 0\n" +
                "            },\n" +
                "            \"COURIER_MATCH\": {},\n" +
                "            \"SPECIAL_MARK\": {},\n" +
                "            \"APPROVE_NEW_BANNER\": {\n" +
                "                \"extend\": \"\",\n" +
                "                \"cofco\": false,\n" +
                "                \"comUid\": \"22768050183124\",\n" +
                "                \"switchId\": 3043,\n" +
                "                \"kohlerCustomize\": false,\n" +
                "                \"zhongTao\": false,\n" +
                "                \"type\": null,\n" +
                "                \"storageUid\": null,\n" +
                "                \"yingTeYiNian\": false,\n" +
                "                \"value\": 0,\n" +
                "                \"xiaoLinZhiYao\": false,\n" +
                "                \"status\": 0\n" +
                "            },\n" +
                "            \"APPROVE_NEW_TIP\": {},\n" +
                "            \"OPEN_SPLIT_OCCUPIED_ITEM\": {\n" +
                "                \"extend\": null,\n" +
                "                \"cofco\": false,\n" +
                "                \"comUid\": \"22768050183124\",\n" +
                "                \"switchId\": 310,\n" +
                "                \"kohlerCustomize\": false,\n" +
                "                \"zhongTao\": false,\n" +
                "                \"type\": null,\n" +
                "                \"storageUid\": null,\n" +
                "                \"yingTeYiNian\": false,\n" +
                "                \"value\": 0,\n" +
                "                \"xiaoLinZhiYao\": false,\n" +
                "                \"status\": 0\n" +
                "            },\n" +
                "            \"WMS_SEND_OUT_SEPARATE\": {},\n" +
                "            \"SPLIT_LIMITATION_ORDER\": {\n" +
                "                \"extend\": null,\n" +
                "                \"cofco\": false,\n" +
                "                \"comUid\": \"22768050183124\",\n" +
                "                \"switchId\": 347,\n" +
                "                \"kohlerCustomize\": false,\n" +
                "                \"zhongTao\": false,\n" +
                "                \"type\": null,\n" +
                "                \"storageUid\": null,\n" +
                "                \"yingTeYiNian\": false,\n" +
                "                \"value\": 0,\n" +
                "                \"xiaoLinZhiYao\": false,\n" +
                "                \"status\": 0\n" +
                "            },\n" +
                "            \"DISTR_MARK_TYPE\": {},\n" +
                "            \"QUERY_GOODS_RIGHT_LIKE\": {},\n" +
                "            \"OPEN_OCCUPY_INVENTORY\": {\n" +
                "                \"extend\": null,\n" +
                "                \"cofco\": false,\n" +
                "                \"comUid\": \"22768050183124\",\n" +
                "                \"switchId\": 1999,\n" +
                "                \"kohlerCustomize\": false,\n" +
                "                \"zhongTao\": false,\n" +
                "                \"type\": null,\n" +
                "                \"storageUid\": null,\n" +
                "                \"yingTeYiNian\": false,\n" +
                "                \"value\": 0,\n" +
                "                \"xiaoLinZhiYao\": false,\n" +
                "                \"status\": 1\n" +
                "            },\n" +
                "            \"REMARK_REPLACED_ORDER\": {\n" +
                "                \"extend\": null,\n" +
                "                \"cofco\": false,\n" +
                "                \"comUid\": \"22768050183124\",\n" +
                "                \"switchId\": 1013,\n" +
                "                \"kohlerCustomize\": false,\n" +
                "                \"zhongTao\": false,\n" +
                "                \"type\": null,\n" +
                "                \"storageUid\": null,\n" +
                "                \"yingTeYiNian\": false,\n" +
                "                \"value\": 0,\n" +
                "                \"xiaoLinZhiYao\": false,\n" +
                "                \"status\": 0\n" +
                "            },\n" +
                "            \"LOT_WAREHOUSE\": {}\n" +
                "        }\n" +
                "    },\n" +
                "    \"loadedDataTypes\": [\n" +
                "        \"dtSearchHistory\",\n" +
                "        \"dtOnwaySearch\",\n" +
                "        \"Entity\",\n" +
                "        \"dtSpecialMark\",\n" +
                "        \"MultiStorage\",\n" +
                "        \"dtSearch\",\n" +
                "        \"DistrCompany\",\n" +
                "        \"dtBackReason\",\n" +
                "        \"Region\",\n" +
                "        \"dtERPVideoStorageBean\",\n" +
                "        \"dtMarkType\",\n" +
                "        \"operBillType\",\n" +
                "        \"Order\",\n" +
                "        \"dtCombination\",\n" +
                "        \"MultiOper\",\n" +
                "        \"Oper\",\n" +
                "        \"dtButtonDiy\",\n" +
                "        \"dtException\",\n" +
                "        \"MultiShop\",\n" +
                "        \"Country\",\n" +
                "        \"Combination\",\n" +
                "        \"dtStorage\",\n" +
                "        \"batchInventory\",\n" +
                "        \"CustomAddress\",\n" +
                "        \"dtVidEquipmentDO\",\n" +
                "        \"Shop\",\n" +
                "        \"dtDistributor\",\n" +
                "        \"multiDistributor\",\n" +
                "        \"dtGroup\",\n" +
                "        \"dtSide\",\n" +
                "        \"PrintConfig\",\n" +
                "        \"dtButton\",\n" +
                "        \"Trade\",\n" +
                "        \"FinAccount\",\n" +
                "        \"CombinationGoods\",\n" +
                "        \"MultiGroupShop\",\n" +
                "        \"Storage\",\n" +
                "        \"dtSysShop\",\n" +
                "        \"dtInvoice\",\n" +
                "        \"dtTradeStatementDetail\",\n" +
                "        \"dtBillRequirements\",\n" +
                "        \"warehouse\",\n" +
                "        \"dtOnway\",\n" +
                "        \"dtDeliveryRequirements\",\n" +
                "        \"GoodsSpec\",\n" +
                "        \"dtQueryCondition\",\n" +
                "        \"dtWriteOff\",\n" +
                "        \"Template\",\n" +
                "        \"dtTradeStatus\",\n" +
                "        \"dtSerialNumber\",\n" +
                "        \"dtTradeAddition\",\n" +
                "        \"dtSalePacking\",\n" +
                "        \"dtTradeTypeDTO\",\n" +
                "        \"TradeOccupyDetail\",\n" +
                "        \"CombinationDetail\",\n" +
                "        \"dtExchange\",\n" +
                "        \"dtMergeLog\",\n" +
                "        \"dtMultiBarcode\",\n" +
                "        \"dtBatch\",\n" +
                "        \"GoodsPermissions\",\n" +
                "        \"dtGoodsUniqueCode\",\n" +
                "        \"dtJzPartner\",\n" +
                "        \"TradeLog\",\n" +
                "        \"dtSearchGoods\",\n" +
                "        \"dtTradeStatement\",\n" +
                "        \"dtWorkOrder\",\n" +
                "        \"dtExchangeRecord\",\n" +
                "        \"dtPackingDetail\",\n" +
                "        \"dtJzPartnerNew\"\n" +
                "    ]\n" +
                "}";
    }


    public static String unicodeDecode(String string) {
        if (StrUtil.isBlank(string)) {
            return StringPool.EMPTY;
        }

        Pattern pattern = Pattern.compile("(\\\\u(\\p{XDigit}{4}))");
        Matcher matcher = pattern.matcher(string);
        char ch;
        while (matcher.find()) {
            ch = (char) Integer.parseInt(matcher.group(2), 16);
            string = string.replace(matcher.group(1), ch + "");
        }
        return string;
    }

}
